commit 50864acee7b02e75e818e5fcab5869856a56abb2
Author: Petr Lukašík <lukasik@rtsoft.cz>
Date:   Mon Jun 10 14:13:21 2019 +0200

    Re #7580 zkoušení nanečisto + výpis

diff --git a/old/html/multidic/app/webroot/examination.php b/old/html/multidic/app/webroot/examination.php
index a4195a3..c119922 100644
--- a/old/html/multidic/app/webroot/examination.php
+++ b/old/html/multidic/app/webroot/examination.php
@@ -3,7 +3,6 @@
 require_once("./functions/dictionary.php");
 
 //pr($_SESSION);flush(1);
-
 if (!kontrola_pristupu(1)) {
   //echo "odhlas";
   Header("Location: .?hlaska=".lang('Došlo k odhlášení')."&n=".$_SESSION["ses_nick"]);
@@ -76,7 +75,7 @@ if (!kontrola_pristupu(1)) {
   $cesta = "./examination/";
 
   //dulezite - urcuje zda jde o learning nebo examination
-  $learning = (strstr(@$_REQUEST['nav_id'], 'learning') != NULL ) ? 'TRUE' : 'FALSE' ;
+  $_REQUEST['learning'] = (strstr(@$_REQUEST['nav_id'], 'learning') != NULL ) ? '1' : '0' ;
 
    //echo $nav_id;
 
diff --git a/old/html/multidic/app/webroot/examination/do_exam.php b/old/html/multidic/app/webroot/examination/do_exam.php
index e929b82..00e01f5 100644
--- a/old/html/multidic/app/webroot/examination/do_exam.php
+++ b/old/html/multidic/app/webroot/examination/do_exam.php
@@ -22,7 +22,7 @@ if (!Empty(@$_REQUEST['action']) && @$_REQUEST['action'] == "do_exam") {
   }
 }
 else if (!Empty(@$_REQUEST['action']) && @$_REQUEST['action'] == "do_learning") {
-  if (!Empty( $sub_button ) && $sub_button == lang("Uměl")) {
+  if (!Empty( @$_REQUEST['sub_button'] ) && @$_REQUEST['sub_button'] == lang("Uměl")) {
     set_exam_status(@$_REQUEST['IDexam'], 1);
     //echo "1";
   }
@@ -55,7 +55,7 @@ if ($slovicko == NULL) {
 $language = $slovicko["language"];
 ?>
 
-<?php if ($learning == 'TRUE') { ?>
+<?php if ($_REQUEST['learning'] == true) { ?>
   <script language="javascript">
 				<!--
 				//doba v sekundach
@@ -111,7 +111,7 @@ $language = $slovicko["language"];
       <tr class="akt">
         <td><?php echo lang("Překlad:") ?></td>
         <td>
-      <?php if ($learning != 'TRUE') { ?>
+      <?php if ($_REQUEST['learning'] != true) { ?>
         <input type="text"
                name="to"
                size="50" />
@@ -132,7 +132,7 @@ $language = $slovicko["language"];
           <input type="hidden" name="IDexam" value="<?php echo $slovicko["IDexam"] ?>">
           <input type="hidden" name="examing" value="<?php echo @$_REQUEST['examing'] ?>">
           <input type="hidden" name="type" value="<?php echo @$_REQUEST['type'] ?>">
-        <?php if ($learning != 'TRUE') { ?>
+        <?php if ($_REQUEST['learning'] != true) { ?>
           <input type="hidden" name="action" value="do_exam">
           <input type="submit" value="<?php echo lang("Dál") ?>">
         <?php } else {?>
@@ -167,7 +167,7 @@ $language = $slovicko["language"];
       <tr class="akt">
         <td><?php echo lang("Překlad:") ?></td>
         <td<?php if ($language == 1 || $language == 2) echo " dir=\"rtl\"" ?>>
-          <?php if ($learning != 'TRUE') { ?>
+          <?php if ($_REQUEST['learning'] != true) { ?>
                       <input  <?php if ($language == 1 || $language == 2) echo "class=\"arabic\"\n         " ?>type="text"
                              name="to"
                              size="20"
@@ -188,7 +188,7 @@ $language = $slovicko["language"];
           <input type="hidden" name="IDexam" value="<?php echo $slovicko["IDexam"] ?>">
           <input type="hidden" name="examing" value="<?php echo @$_REQUEST['examing'] ?>">
           <input type="hidden" name="type" value="<?php echo @$_REQUEST['type'] ?>">
-          <?php if ($learning != 'TRUE') { ?>
+          <?php if ($_REQUEST['learning'] != true) { ?>
           <input type="hidden" name="action" value="do_exam">
           <input type="submit" value="<?php echo lang("Dál") ?>">
         <?php } else {?>
@@ -205,7 +205,7 @@ $language = $slovicko["language"];
 
 <?php endif; ?>
 
-<?php if ($learning != 'TRUE') { ?>
+<?php if ($_REQUEST['learning'] != true) { ?>
 
 <div id="key">
   <?php
diff --git a/old/html/multidic/app/webroot/examination/new_exam.php b/old/html/multidic/app/webroot/examination/new_exam.php
index 4e43651..9e01d2e 100644
--- a/old/html/multidic/app/webroot/examination/new_exam.php
+++ b/old/html/multidic/app/webroot/examination/new_exam.php
@@ -111,7 +111,7 @@ switch ($krok) {
   case (3):
   $IDexaming = create_examing($_SESSION['ses_IDuser'], @$_REQUEST['source'], @$_REQUEST['lection'], @$_REQUEST['count'], @$_REQUEST['type'], @$_REQUEST['learning']);
   
-  $pomoc = (@$_REQUEST['learning'] == 'TRUE')? 'learning' : 'exam';
+  $pomoc = (@$_REQUEST['learning'] == true)? 'learning' : 'exam';
 ?>
 <h3 class="nadpis2"><?php echo lang("Zkoušení vytvořeno") ?></h3>
 <a href="?nav_id=do_<?php 